// Cookies.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifdef _WIN32
#pragma warning(disable:4786)
#define strcasecmp stricmp
#endif
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "Cookies.h"
#include "Parse.h"
//#include "list.h"


static	char *days[7] = {"Sunday","Monday",
	 "Tuesday","Wednesday","Thursday","Friday","Saturday"};
static	char *months[12] = {"Jan","Feb","Mar","Apr","May",
	 "Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

Cookies::Cookies(void)
{
//	cookiebase = NULL;
}

Cookies::Cookies(char *s)
{
	COOKIE *c = NULL;
	cgi::Parse *pa = new cgi::Parse(s,";");
	cgi::Parse *pa2;
	char slask[500];
	char name[500];
	char value[500];

//	cookiebase = NULL;

	pa -> getword(slask);
	while (*slask)
	{
		pa2 = new cgi::Parse(slask,"=");
		pa2 -> getword(name);
		pa2 -> getword(value);
		delete pa2;
		c = new COOKIE;
		c -> name = new char[strlen(name) + 1];
		strcpy(c -> name,name);
		c -> value = new char[strlen(value) + 1];
		strcpy(c -> value,value);
//		addlist(&cookiebase,c);
		m_cookies.push_back(c);
		//
		pa -> getword(slask);
	}
	delete pa;
}

Cookies::~Cookies(void)
{
	COOKIE *c = NULL; //,*tmp;

//	for (c = cookiebase; c; c = tmp)
	for (cookie_v::iterator it = m_cookies.begin(); it != m_cookies.end(); it++)
	{
		c = *it;
		delete[] c -> name;
		delete[] c -> value;
//		tmp = c -> next;
		delete c;
	}
}

int Cookies::getvalue(char *name,char *buffer,short length)
{
	COOKIE *c = NULL;

//	for (c = cookiebase; c; c = c -> next)
	for (cookie_v::iterator it = m_cookies.begin(); it != m_cookies.end(); it++)
	{
		c = *it;
		if (!strcasecmp(c -> name,name))
			break;
		c = NULL;
	}
	if (c)
	{
		if ((short)strlen(c -> value) >= length)
		{
			strncpy(buffer,c -> value,length - 1);
			buffer[length - 1] = 0;
		} else
			strcpy(buffer,c -> value);
		return 1;
	} else
	{
		*buffer = 0;
		return 0;
	}
}

void Cookies::replacevalue(char *name,char *value)
{
	COOKIE *c = NULL;
	
//	for (c = cookiebase; c; c = c -> next)
	for (cookie_v::iterator it = m_cookies.begin(); it != m_cookies.end(); it++)
	{
		c = *it;
		if (!strcasecmp(c -> name,name))
			break;
		c = NULL;
	}

	if (c)
	{
		if (strlen(value) > strlen(c -> value))
		{
			delete[] c -> value;
			c -> value = new char[strlen(value) + 1];
		}
		strcpy(c -> value,value);
	} else
	{
		c = new COOKIE;
		c -> name = new char[strlen(name) + 1];
		strcpy(c -> name,name);
		c -> value = new char[strlen(value) + 1];
		strcpy(c -> value,value);
//		addlist(&cookiebase,c);
		m_cookies.push_back(c);
	}
}

void Cookies::replacevalue(char *name,long l)
{
	char slask[100];

	sprintf(slask,"%ld",l);
	replacevalue(name,slask);
}

void Cookies::replacevalue(char *name,int i)
{
	char slask[100];

	sprintf(slask,"%d",i);
	replacevalue(name,slask);
}

int Cookies::getlength(char *name)
{
	COOKIE *c = NULL;

//	for (c = cookiebase; c; c = c -> next)
	for (cookie_v::iterator it = m_cookies.begin(); it != m_cookies.end(); it++)
	{
		c = *it;
		if (!strcasecmp(c -> name,name))
			break;
		c = NULL;
	}
	return c ? strlen(c -> value) : 0;
}

void Cookies::setcookie(char *domain,char *path,char *name,char *value)
{
	char dt[80];

	Cookies::expiredatetime(dt);

	// set-cookie response
	printf("Set-Cookie: %s=%s; domain=%s; path=%s; expires=%s\n",
	 name,value,
	 domain,
	 path,
	 dt);
	Cookies::replacevalue(name,value);
}

void Cookies::setcookie(char *domain,char *path,char *name,long value)
{
	char dt[80];

	Cookies::expiredatetime(dt);

	// set-cookie response
	printf("Set-Cookie: %s=%ld; domain=%s; path=%s; expires=%s\n",
	 name,value,
	 domain,
	 path,
	 dt);
	sprintf(dt,"%ld",value);
	Cookies::replacevalue(name,dt);
}

void Cookies::setcookie(char *domain,char *path,char *name,int value)
{
	char dt[80];

	Cookies::expiredatetime(dt);

	// set-cookie response
	printf("Set-Cookie: %s=%d; domain=%s; path=%s; expires=%s\n",
	 name,value,
	 domain,
	 path,
	 dt);
	sprintf(dt,"%d",value);
	Cookies::replacevalue(name,dt);
}

void Cookies::expiredatetime(char *dt)
{
	time_t t = time(NULL);
	struct tm * tp = gmtime(&t);

	sprintf(dt,"%s, %02d-%s-%04d %02d:%02d:%02d GMT",
	 days[tp -> tm_wday],
	 tp -> tm_mday,
	 months[tp -> tm_mon],
	 tp -> tm_year + 1910,
	 tp -> tm_hour,
	 tp -> tm_min,
	 tp -> tm_sec);
}

